$(document).ready(function() {
	var canvas = document.getElementById("canvas1");
	var ctx = canvas.getContext("2d");
	var windowHeight = $(window).height();
	var windowWidth = $(window).width();
	var canvasHeight = windowHeight - 8;
	var canvasWidth = windowWidth - 8;
	canvas.width = canvasWidth;
	canvas.height = canvasHeight;
	var deg = 0;
	var slideGlockReady = false; 
	var bottomGlockReady = false;
	var arrowReady = false;
	var bulletReady = false;
	var glockSlideHeight = 53;
	var glockSlideWidth = 300;
	var xCoordForSlide = 0;
	var glockBottomHeight = 180;
	var glockBottomWidth = 300;
	var bulletHeight = 50;
	var bulletWidth = 60;
	var gunHeight = glockSlideHeight + glockBottomHeight;
	var middleOfGun = gunHeight / 2;
	var middleOfCanvas = canvasHeight / 2;
	var yCoordForSlide = middleOfCanvas - middleOfGun;
	var yCoordForBottom = yCoordForSlide + (glockSlideHeight - 3);
	var yCoordForBullet = yCoordForSlide + (bulletHeight / 2);
	var xCoordForBullet = glockSlideWidth;
	var bulletImage = new Image();
	var moveBullet;
	/*(function() {
		ctx.beginPath();
      	ctx.moveTo(0, middleOfCanvas);
      	ctx.lineTo(155000, 0);
      	ctx.closePath();
      	ctx.stroke();
	})();*/

	
	//Slide of the Glock
	function loadGlockSlide() {
		var slideGlockImage = new Image();
		slideGlockImage.onload = function() {
			slideGlockReady = true;
			// ctx.rotate(degForGlockSlide * Math.PI / 180);
			// Here is  ^  the amount of degrees it turns.
			ctx.drawImage(slideGlockImage, 0, yCoordForSlide, glockSlideWidth, glockSlideHeight);
			// rotateGlockSlide();
			cockBack();
			function rotateGlockSlide() {
				var moveGlockSlide = setInterval(function() {
					if (deg == 13) {
						clearInterval(moveGlockSlide);
						return rotateGlockSlideBack();
					}
					ctx.save();
					// console.log(degForGlockSlide);
					ctx.rotate(deg * Math.PI / 180);
					// Here is the ^ amount of degrees it turns
					// ctx.clearRect(7, 120, 310, 68);
					// ctx.drawImage(slideGlockImage, 10, 120, 300, 58);
					ctx.restore();
				}, 48);
			}
			function rotateGlockSlideBack() {
				var moveGlockSlideBack = setInterval(function() {
					if (deg == -13) {
						clearInterval(moveGlockSlideBack);
						return rotateGlockSlide();
					}
					ctx.save();
					// console.log(degForGlockSlide);
					ctx.rotate(deg * Math.PI / 180);
					// ctx.clearRect(7, 110, 310, 68)
					// ctx.drawImage(slideGlockImage, 10, 120, 300, 58);
					ctx.restore();
				}, 48);
			}	
			function cockBack() {
				$("canvas").click(function() {
					var moveBack = setInterval(function() {
						if(xCoordForSlide == -15) {
							clearInterval(moveBack);
							return cockForward();
						}
						xCoordForSlide--;
						ctx.clearRect(xCoordForSlide, yCoordForSlide, glockSlideWidth, glockSlideHeight);
						ctx.drawImage(slideGlockImage, xCoordForSlide, yCoordForSlide, glockSlideWidth, glockSlideHeight);
					}, 10);
				});
			}
			function cockForward() {
				var moveForward = setInterval(function() {
					if(xCoordForSlide == 0) {
						clearInterval(moveForward);
					}
					xCoordForSlide++;
					ctx.clearRect(xCoordForSlide, yCoordForSlide, glockSlideWidth, glockSlideHeight);
					ctx.drawImage(slideGlockImage, xCoordForSlide, yCoordForSlide, glockSlideWidth, glockSlideHeight);
				}, 10);
			}
		}
		
		slideGlockImage.src = "imgs/glock-slide.png";
	}

	//Bottom Part of the Glock
	function loadGlockBottom() {
		var bottomGlockImage = new Image();
		bottomGlockImage.onload = function () {
			bottomGlockReady = true;
			if (slideGlockReady == true) {
				rotateGlockBottom();
				ctx.drawImage(bottomGlockImage, 0, yCoordForBottom, glockBottomWidth, glockBottomHeight);
				function rotateGlockBottom() {
					var moveGlockBottom = setInterval(function() {
						if (deg == 13) {
							clearInterval(moveGlockBottom);
							return rotateGlockBottomBack();
						}
						ctx.save();
						// console.log(deg);
						ctx.rotate(deg * Math.PI / 180);
						// ctx.clearRect(5, 170, 310, 190);
						// ctx.drawImage(bottomGlockImage, 10, 170, 300, 180);
						ctx.restore();
					}, 48);
				}
				function rotateGlockBottomBack() {
					var moveGlockBottomBack = setInterval(function() {
						if(deg == -13) {
							clearInterval(moveGlockBottomBack);
							return rotateGlockBottom();
						}
						ctx.save();
						// console.log(deg);
						ctx.rotate(deg * Math.PI / 180);
						// ctx.clearRect(5, 170, 310, 190);
						// ctx.drawImage(bottomGlockImage, 10, 170, 300, 180);
						ctx.restore();
					}, 48);
				}
			}
		};
		bottomGlockImage.src = "imgs/glock-no-slide.png";
	}

	function loadArrow() {
		var arrowImage = new Image();
		arrowImage.onload = function () {
			arrowReady = true;
			moveArrow();
			ctx.drawImage(arrowImage, 320, 100, 42, 300);
			function moveArrow() {
	    		var moveArrowInterval = setInterval(function() {
	        		if (deg == 15) {
	            		clearInterval(moveArrowInterval);
	            		return moveArrowBack();
	        		}
	        		ctx.save();
	        		// deg++;
	        		// console.log(deg)
	        		ctx.rotate(deg * Math.PI / 180);
	        		// Here is  ^  the amount of degrees it turns.
	        		ctx.clearRect(320, 200, 52, 310);
	        		ctx.drawImage(arrowImage, 320, 100, 42, 300);
	        		ctx.restore();
	        	}, 50);
	    	}
			function moveArrowBack() {
	    		var moveArrowBackInterval = setInterval(function() {
	        		if (deg == -10) {
	            		clearInterval(moveArrowBackInterval);
	            		return moveArrow();
	        		}
	        		ctx.save();
	        		// deg--;
	        		// console.log(deg)
	        		ctx.rotate(deg * Math.PI / 180);
	        		// Here is  ^  the amount of degrees it turns.
	        		ctx.clearRect(313, 200, 52, 310);
	        		ctx.drawImage(arrowImage, 320, 100, 42, 300);
	        		ctx.restore();
	        	}, 50);
	    	}
	    }
		
		arrowImage.src = "imgs/arrow.png";
	}
	//Load Bullet
	function loadBullet() {
		$(canvas).click(function() {
			bulletImage.onload = function() {
				bulletReady = true;
				ctx.drawImage(bulletImage, xCoordForBullet, yCoordForBullet, bulletWidth, bulletHeight);
				animateBullet();
			}
			bulletImage.src = "imgs/bullet.png";
		});
		function animateBullet() {
			moveBullet = setInterval(function() {
				if(xCoordForBullet >= canvasWidth - (bulletWidth + 15)) {
					clearInterval(moveBullet);
					moveBullet = null;
					if (!moveBullet) {
						bulletHole();
						console.log('test');
					}
				}
				xCoordForBullet = xCoordForBullet + 10;
				// console.log(xCoordForBullet);
				ctx.clearRect(xCoordForBullet - 10, yCoordForBullet - 10, bulletWidth + 10, bulletHeight + 10);
				ctx.drawImage(bulletImage, xCoordForBullet, yCoordForBullet, bulletWidth, bulletHeight);
			}, 50);
		}
		function bulletHole() {
			// alert('yay!!!');
			
		}
	}


	function render() {
		loadBullet();
 		loadGlockSlide();
 		loadGlockBottom();
 		loadArrow();
	}

	render();
});